Index: /BAORadio/libindi/libindi/libs/indibase/defaultdriver.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/defaultdriver.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/defaultdriver.cpp	(revision 642)
@@ -1,2 +1,20 @@
+/*******************************************************************************
+  Copyright(c) 2011 Jasem Mutlaq. All rights reserved.
+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
+
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
+*******************************************************************************/
+
 #include <stdlib.h>
 #include <string.h>
@@ -8,4 +26,13 @@
 #include "base64.h"
 
+const char *COMMUNICATION_TAB = "Communication";
+const char *MAIN_CONTROL_TAB = "Main Control";
+const char *MOTION_TAB = "Motion Control";
+const char *DATETIME_TAB = "Date/Time";
+const char *SITE_TAB = 	"Site Management";
+const char *OPTIONS_TAB = "Options";
+const char *FILTER_TAB = "Filter Wheel";
+const char *GUIDER_TAB = "Guide Wheel";
+
 void timerfunc(void *t)
 {
@@ -30,4 +57,7 @@
     //switchPtr conSw(new ISwitchVectorProperty);
     ConnectionSP = new ISwitchVectorProperty;
+    DebugSP = NULL;
+    SimulationSP = NULL;
+    ConfigProcessSP = NULL;
 
     IUFillSwitch(&ConnectionS[0],"CONNECT","Connect",ISS_OFF);
@@ -35,6 +65,14 @@
     IUFillSwitchVector(ConnectionSP,ConnectionS,2,deviceName(),"CONNECTION","Connection","Main Control",IP_RW,ISR_1OFMANY,60,IPS_IDLE);
 
-    registerProperty(ConnectionSP, INDI_SWITCH);
-
+    registerProperty(ConnectionSP, PropertyContainer::INDI_SWITCH);
+
+}
+
+INDI::DefaultDriver::~DefaultDriver()
+{
+    delete ConnectionSP;
+    delete DebugSP;
+    delete SimulationSP;
+    delete ConfigProcessSP;
 }
 
@@ -47,5 +85,7 @@
 
    if (pResult)
-       IDMessage(deviceID, "Configuration successfully loaded.");
+       IDMessage(deviceID, "Configuration successfully loaded.\n");
+	else
+		IDMessage(deviceID,"Error loading configuration\n");
 
    IUSaveDefaultConfig(NULL, NULL, deviceID);
@@ -54,9 +94,10 @@
 }
 
-bool INDI::DefaultDriver::saveConfig()
-{
-    //std::vector<orderPtr>::iterator orderi;
-
-    std::map< boost::shared_ptr<void>, INDI_TYPE>::iterator orderi;
+bool INDI::DefaultDriver::saveConfigItems(FILE *fp)
+{
+    std::vector<PropertyContainer *>::iterator orderi;
+
+    PropertyContainer::INDI_TYPE pType;
+    void *pPtr;
 
     ISwitchVectorProperty *svp=NULL;
@@ -64,33 +105,24 @@
     ITextVectorProperty   *tvp=NULL;
     IBLOBVectorProperty   *bvp=NULL;
-    char errmsg[MAXRBUF];
-    FILE *fp = NULL;
-
-    fp = IUGetConfigFP(NULL, deviceID, errmsg);
-
-    if (fp == NULL)
-    {
-        IDMessage(deviceID, "Error saving configuration. %s", errmsg);
-        return false;
-    }
-
-    IUSaveConfigTag(fp, 0);
 
     for (orderi = pAll.begin(); orderi != pAll.end(); orderi++)
     {
 
-        switch (orderi->second)
+        pType       = (*orderi)->getType();
+        pPtr        = (*orderi)->getProperty();
+
+        switch (pType)
         {
-        case INDI_NUMBER:
-             nvp = static_cast<INumberVectorProperty *>((orderi->first).get());
-             IDLog("Trying to save config for number %s\n", nvp->name);
+        case PropertyContainer::INDI_NUMBER:
+             nvp = static_cast<INumberVectorProperty *>(pPtr);
+             //IDLog("Trying to save config for number %s\n", nvp->name);
              IUSaveConfigNumber(fp, nvp);
              break;
-        case INDI_TEXT:
-             tvp = static_cast<ITextVectorProperty *>((orderi->first).get());
+        case PropertyContainer::INDI_TEXT:
+             tvp = static_cast<ITextVectorProperty *>(pPtr);
              IUSaveConfigText(fp, tvp);
              break;
-        case INDI_SWITCH:
-             svp = static_cast<ISwitchVectorProperty *>((orderi->first).get());
+        case PropertyContainer::INDI_SWITCH:
+             svp = static_cast<ISwitchVectorProperty *>(pPtr);
              /* Never save CONNECTION property. Don't save switches with no switches on if the rule is one of many */
              if (!strcmp(svp->name, "CONNECTION") || (svp->r == ISR_1OFMANY && !IUFindOnSwitch(svp)))
@@ -98,10 +130,31 @@
              IUSaveConfigSwitch(fp, svp);
              break;
-        case INDI_BLOB:
-             bvp = static_cast<IBLOBVectorProperty *>((orderi->first).get());
+        case PropertyContainer::INDI_BLOB:
+             bvp = static_cast<IBLOBVectorProperty *>(pPtr);
              IUSaveConfigBLOB(fp, bvp);
              break;
         }
     }
+	return true;
+}
+
+bool INDI::DefaultDriver::saveConfig()
+{
+    //std::vector<orderPtr>::iterator orderi;
+    char errmsg[MAXRBUF];
+
+    FILE *fp = NULL;
+
+    fp = IUGetConfigFP(NULL, deviceID, errmsg);
+
+    if (fp == NULL)
+    {
+        IDMessage(deviceID, "Error saving configuration. %s\n", errmsg);
+        return false;
+    }
+
+    IUSaveConfigTag(fp, 0);
+
+	saveConfigItems(fp);
 
     IUSaveConfigTag(fp, 1);
@@ -142,5 +195,4 @@
 bool INDI::DefaultDriver::ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n)
 {
-
     // ignore if not ours //
     if (strcmp (dev, deviceID))
@@ -160,4 +212,5 @@
         if ( !strcmp(names[i], "CONNECT") && (states[i] == ISS_ON))
         {
+
             // If not connected, attempt to connect
             if (isConnected() == false)
@@ -167,7 +220,8 @@
                 // If connection is successful, set it thus
                 if (rc)
-                  setConnected(true);
+                        setConnected(true, IPS_OK);
                 else
-                  setConnected(false, IPS_ALERT);
+                        setConnected(false, IPS_ALERT);
+
 
                 updateProperties();
@@ -261,10 +315,9 @@
     if (!DebugSP)
     {
-        switchPtr debSw(new ISwitchVectorProperty);
-        DebugSP = debSw.get();
+        DebugSP = new ISwitchVectorProperty;
         IUFillSwitch(&DebugS[0], "ENABLE", "Enable", ISS_OFF);
         IUFillSwitch(&DebugS[1], "DISABLE", "Disable", ISS_ON);
-        IUFillSwitchVector(DebugSP, DebugS, NARRAY(DebugS), deviceID, "DEBUG", "Debug", "Options", IP_RW, ISR_1OFMANY, 0, IPS_IDLE);
-        pAll[debSw] = INDI_SWITCH;
+        IUFillSwitchVector(DebugSP, DebugS, NARRAY(DebugS), deviceName(), "DEBUG", "Debug", "Options", IP_RW, ISR_1OFMANY, 0, IPS_IDLE);
+        registerProperty(DebugSP, PropertyContainer::INDI_SWITCH);
     }
     else
@@ -285,10 +338,9 @@
     if (!SimulationSP)
     {
-        switchPtr simSw(new ISwitchVectorProperty);
-        SimulationSP = simSw.get();
+        SimulationSP = new ISwitchVectorProperty;
         IUFillSwitch(&SimulationS[0], "ENABLE", "Enable", ISS_OFF);
         IUFillSwitch(&SimulationS[1], "DISABLE", "Disable", ISS_ON);
-        IUFillSwitchVector(SimulationSP, SimulationS, NARRAY(SimulationS), deviceID, "SIMULATION", "Simulation", "Options", IP_RW, ISR_1OFMANY, 0, IPS_IDLE);
-        pAll[simSw] = INDI_SWITCH;
+        IUFillSwitchVector(SimulationSP, SimulationS, NARRAY(SimulationS), deviceName(), "SIMULATION", "Simulation", "Options", IP_RW, ISR_1OFMANY, 0, IPS_IDLE);
+        registerProperty(SimulationSP, PropertyContainer::INDI_SWITCH);
     }
     else
@@ -307,11 +359,10 @@
     if (!ConfigProcessSP)
     {
-        switchPtr configSw(new ISwitchVectorProperty);
-        ConfigProcessSP = configSw.get();
+        ConfigProcessSP = new ISwitchVectorProperty;
         IUFillSwitch(&ConfigProcessS[0], "CONFIG_LOAD", "Load", ISS_OFF);
         IUFillSwitch(&ConfigProcessS[1], "CONFIG_SAVE", "Save", ISS_OFF);
         IUFillSwitch(&ConfigProcessS[2], "CONFIG_DEFAULT", "Default", ISS_OFF);
-        IUFillSwitchVector(ConfigProcessSP, ConfigProcessS, NARRAY(ConfigProcessS), deviceID, "CONFIG_PROCESS", "Configuration", "Options", IP_RW, ISR_1OFMANY, 0, IPS_IDLE);
-        pAll[configSw] = INDI_SWITCH;
+        IUFillSwitchVector(ConfigProcessSP, ConfigProcessS, NARRAY(ConfigProcessS), deviceName(), "CONFIG_PROCESS", "Configuration", "Options", IP_RW, ISR_1OFMANY, 0, IPS_IDLE);
+        registerProperty(ConfigProcessSP, PropertyContainer::INDI_SWITCH);
     }
     /**************************************************************************/
@@ -416,8 +467,9 @@
 void INDI::DefaultDriver::ISGetProperties (const char *dev)
 {
-    std::map< boost::shared_ptr<void>, INDI_TYPE>::iterator orderi;
+    std::vector<PropertyContainer *>::iterator orderi;
     static int isInit = 0;
-
-    //fprintf(stderr,"Enter ISGetProperties '%s'\n",dev);
+    PropertyContainer::INDI_TYPE pType;
+    void *pPtr;
+
     if(isInit == 0)
     {
@@ -442,20 +494,23 @@
     for (orderi = pAll.begin(); orderi != pAll.end(); orderi++)
     {
-        switch (orderi->second)
+        pType       = (*orderi)->getType();
+        pPtr        = (*orderi)->getProperty();
+
+        switch (pType)
         {
-        case INDI_NUMBER:
-             IDDefNumber(static_cast<INumberVectorProperty *>((orderi->first).get()) , NULL);
-             break;
-        case INDI_TEXT:
-             IDDefText(static_cast<ITextVectorProperty *>((orderi->first).get()) , NULL);
-             break;
-        case INDI_SWITCH:
-             IDDefSwitch(static_cast<ISwitchVectorProperty *>((orderi->first).get()) , NULL);
-             break;
-        case INDI_LIGHT:
-             IDDefLight(static_cast<ILightVectorProperty *>((orderi->first).get()) , NULL);
-             break;
-        case INDI_BLOB:
-             IDDefBLOB(static_cast<IBLOBVectorProperty *>((orderi->first).get()) , NULL);
+        case PropertyContainer::INDI_NUMBER:
+             IDDefNumber(static_cast<INumberVectorProperty *>(pPtr) , NULL);
+             break;
+        case PropertyContainer::INDI_TEXT:
+             IDDefText(static_cast<ITextVectorProperty *>(pPtr) , NULL);
+             break;
+        case PropertyContainer::INDI_SWITCH:
+             IDDefSwitch(static_cast<ISwitchVectorProperty *>(pPtr) , NULL);
+             break;
+        case PropertyContainer::INDI_LIGHT:
+             IDDefLight(static_cast<ILightVectorProperty *>(pPtr) , NULL);
+             break;
+        case PropertyContainer::INDI_BLOB:
+             IDDefBLOB(static_cast<IBLOBVectorProperty *>(pPtr) , NULL);
              break;
         }
@@ -535,13 +590,13 @@
 //  This is a helper function
 //  that just encapsulates the Indi way into our clean c++ way of doing things
-int INDI::DefaultDriver::SetTimer(int t)
-{
-    return IEAddTimer(t,timerfunc,this);
+int INDI::DefaultDriver::SetTimer(int ms)
+{
+    return IEAddTimer(ms,timerfunc,this);
 }
 
 //  Just another helper to help encapsulate indi into a clean class
-void INDI::DefaultDriver::RemoveTimer(int t)
-{
-    IERmTimer(t);
+void INDI::DefaultDriver::RemoveTimer(int id)
+{
+    IERmTimer(id);
     return;
 }
@@ -577,5 +632,5 @@
 void INDI::DefaultDriver::defineNumber(INumberVectorProperty *nvp)
 {
-    registerProperty(nvp, INDI_NUMBER);
+    registerProperty(nvp, PropertyContainer::INDI_NUMBER);
     IDDefNumber(nvp, NULL);
 }
@@ -583,5 +638,5 @@
 void INDI::DefaultDriver::defineText(ITextVectorProperty *tvp)
 {
-    registerProperty(tvp, INDI_TEXT);
+    registerProperty(tvp, PropertyContainer::INDI_TEXT);
     IDDefText(tvp, NULL);
 }
@@ -589,5 +644,5 @@
 void INDI::DefaultDriver::defineSwitch(ISwitchVectorProperty *svp)
 {
-    registerProperty(svp, INDI_SWITCH);
+    registerProperty(svp, PropertyContainer::INDI_SWITCH);
     IDDefSwitch(svp, NULL);
 }
@@ -595,5 +650,5 @@
 void INDI::DefaultDriver::defineLight(ILightVectorProperty *lvp)
 {
-    registerProperty(lvp, INDI_LIGHT);
+    registerProperty(lvp, PropertyContainer::INDI_LIGHT);
     IDDefLight(lvp, NULL);
 }
@@ -601,5 +656,5 @@
 void INDI::DefaultDriver::defineBLOB(IBLOBVectorProperty *bvp)
 {
-    registerProperty(bvp, INDI_BLOB);
+    registerProperty(bvp, PropertyContainer::INDI_BLOB);
     IDDefBLOB(bvp, NULL);
 }
Index: /BAORadio/libindi/libindi/libs/indibase/defaultdriver.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/defaultdriver.h	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/defaultdriver.h	(revision 642)
@@ -1,2 +1,20 @@
+/*******************************************************************************
+  Copyright(c) 2011 Jasem Mutlaq. All rights reserved.
+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
+
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
+*******************************************************************************/
+
 #ifndef INDIDEFAULTDRIVER_H
 #define INDIDEFAULTDRIVER_H
@@ -5,7 +23,18 @@
 #include "indidriver.h"
 
+#include <auto_ptr.h>
+
+extern const char *COMMUNICATION_TAB;
+extern const char *MAIN_CONTROL_TAB;
+extern const char *MOTION_TAB;
+extern const char *DATETIME_TAB;
+extern const char *SITE_TAB;
+extern const char *OPTIONS_TAB;
+extern const char *FILTER_TAB;
+extern const char *GUIDER_TAB;
+
 /**
  * \class INDI::DefaultDriver
-   \brief Class to provide extended functionary for drivers in addition
+   \brief Class to provide extended functionality for drivers in addition
 to the functionality provided by INDI::BaseDriver. This class should \e only be subclassed by
 drivers directly as it is linked with main(). Virtual drivers cannot employ INDI::DefaultDriver.
@@ -21,5 +50,5 @@
 public:
     DefaultDriver();
-    virtual ~DefaultDriver() {}
+    virtual ~DefaultDriver();
 
     /** \brief Add Debug, Simulation, and Configuration options to the driver */
@@ -74,13 +103,26 @@
     virtual bool deleteProperty(const char *propertyName);
 
-    /** \brief Connect or Disconnect a device.
+
+    /** \brief Set connection switch status in the client.
       \param status If true, the driver will attempt to connect to the device (CONNECT=ON). If false, it will attempt
 to disconnect the device.
-      \param msg A message to be sent along with connect/disconnect command.
+      \param status True to set CONNECT on, false to set DISCONNECT on.
+      \param state State of CONNECTION properti, by default IPS_OK.
+      \param msg A message to be sent along with connect/disconnect command, by default NULL.
     */
     virtual void setConnected(bool status, IPState state=IPS_OK, const char *msg = NULL);
 
-    int SetTimer(int);
-    void RemoveTimer(int);
+    /** \brief Set a timer to call the function TimerHit after ms milliseconds
+        \param ms timer duration in milliseconds.
+        \return id of the timer to be used with RemoveTimer
+   */
+    int SetTimer(int ms);
+
+    /** \brief Remove timer added with SetTimer
+        \param id ID of the timer as returned from SetTimer
+   */
+    void RemoveTimer(int id);
+
+    /** \brief Callback function to be called once SetTimer duration elapses. */
     virtual void TimerHit();
 
@@ -116,15 +158,17 @@
         \return True if successful, false otherwise.
     */
-    bool loadConfig();
+    virtual bool loadConfig();
 
     /** \brief Save the current properties in a configuration file
         \return True if successful, false otherwise.
     */
-    bool saveConfig();
+    virtual bool saveConfig();
+    virtual bool saveConfigItems(FILE *fp);
 
     /** \brief Load the default configuration file
         \return True if successful, false otherwise.
     */
-    bool loadDefaultConfig();
+    virtual bool loadDefaultConfig();
+
 
     // Simulatin & Debug
Index: /BAORadio/libindi/libindi/libs/indibase/indibase.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indibase.h	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/indibase.h	(revision 642)
@@ -9,5 +9,7 @@
 /**
  * \namespace INDI
-   \brief Namespace to encapsulate INDI client, device, and mediator classes
+   \brief Namespace to encapsulate INDI client, drivers, and mediator classes.
+   Developers can subclass the base devices class to implement device specific functionality. This ensures interoperability and consistency among devices within the same family
+   and reduces code overhead.
 
    <ul>
@@ -18,4 +20,11 @@
    <li>DefaultDriver: INDI::BaseDriver with extended functionality such as debug, simulation, and configuration support.
        It is \e only used by drivers directly, it cannot be used by clients.</li>
+   <li>FilterInterface: Basic interface for filter wheels functions.</li>
+   <li>GuiderInterface: Basic interface for guider (ST4) port functions.</li>
+   <li>CCD: Base class for CCD drivers. Provides basic support for single chip CCD and CCDs with a guide head as well.</li>
+   <li>Telescope: Base class for telescope drivers.</li>
+   <li>FilterWheel: Base class for Filter Wheels. It implements the FilterInterface.</li>
+   <li>Focuser: Base class for focusers.</li>
+   <li>USBDevice: Base class for USB devices for direct read/write/control over USB.</li>
    </ul>
  */
@@ -26,9 +35,11 @@
     class BaseDriver;
     class DefaultDriver;
+    class FilterInterface;
+    class GuiderInterface;
     class CCD;
     class Telescope;
     class FilterWheel;
     class Focuser;
-    class USBDevice;
+    class USBDevice;   
 }
 
